///<reference path="../.d.ts"/>
"use strict";
var path = require("path");
var util = require("util");
var PreUninstallCommand = (function () {
    function PreUninstallCommand($fs, $childProcess, $logger, $options) {
        this.$fs = $fs;
        this.$childProcess = $childProcess;
        this.$logger = $logger;
        this.$options = $options;
        this.disableAnalytics = true;
        this.allowedParameters = [];
    }
    PreUninstallCommand.prototype.execute = function (args) {
        var _this = this;
        return (function () {
            var relativeAdbPath = util.format(PreUninstallCommand.ADB_RELATIVE_PATH, process.platform);
            var adbPath = path.join(__dirname, relativeAdbPath);
            var killAdbServerCommand = util.format("\"%s\" kill-server", adbPath);
            _this.$logger.warn("Trying to kill adb server. Some running Android related operations may fail.");
            try {
                _this.$childProcess.exec(killAdbServerCommand).wait();
            }
            catch (err) {
                _this.$logger.trace(err);
                _this.$logger.warn("Unable to kill adb server.");
            }
            _this.$fs.deleteFile(path.join(_this.$options.profileDir, "KillSwitches", "cli")).wait();
        }).future()();
    };
    PreUninstallCommand.ADB_RELATIVE_PATH = "../resources/platform-tools/android/%s/adb";
    return PreUninstallCommand;
})();
exports.PreUninstallCommand = PreUninstallCommand;
$injector.registerCommand("dev-preuninstall", PreUninstallCommand);
